//
// card.c
//
// This file contains code for the Microchip PIC16F877 (Silver Card) for CCS PCM
//
// Written by Joe Grand, 2009
// See http://www.grandideastudio.com/portfolio/smart-parking-meters/
//
// All data values have been replaced with 0xFF
//

#include "card.h"

void main (void)
{
    port_b_pullups(FALSE); // disable port B pull-ups

	atr();
    manufacturer();
    issuer_area();
	current_value();

	while(1)
	{	
		issuer_area();
		deposit_coin();
	}
}

void atr(void)
{
	delay_ms(1);

	// send ATR
	putc(0xFF);delay_us(170); // smartcard guard time
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);
}

void manufacturer(void)
{
    output_float(SIO);
    while (getc() != 0xFF); // wait for query from meter
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);
}


void issuer_area(void)
{
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);
}

void current_value(void)
{
	// CSC1 ratification counter	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    // verify/present CSC1 password	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);
    delay_us(500);

    output_float(SIO);
    while (getc() != 0xFF); // get computed password from meter
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_ms(3); 
	putc(0xFF);delay_us(170); // respond "OK!"
	putc(0xFF);

    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    // CTC1 transaction counter	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170); 
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170); 
	putc(0xFF);delay_us(170); 
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);

    // CTC1 transaction counter	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);delay_us(170); 
	putc(0xFF);delay_us(170); 
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);delay_us(170);
	putc(0xFF);
}

void deposit_coin(void)
{
    // update balance 1, current value A1	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);
    delay_us(500);

    output_float(SIO);
    while (getc() != 0xFF); // get computed password from meter
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_ms(5); 
	putc(0xFF);delay_us(170); // respond "OK!"
	putc(0xFF);

    // update balance 1, current value A2	
    output_float(SIO);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_us(500);
	putc(0xFF);
    delay_us(500);

    output_float(SIO);
    while (getc() != 0xFF); // get computed password from meter
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    while (getc() != 0xFF);
    delay_ms(5); 
	putc(0xFF);delay_us(170); // respond "OK!"
	putc(0xFF);
}
